Bug 7370 - ICE in fixup_var_refs_1 on s390x
ICE in fixup_var_refs_1 on s390x
Status: RESOLVED FIXED
Product: gcc
Classification: Unclassified
Component: target
3.1.1
: P3 normal
: ---
Assigned To: Ulrich Weigand
: ice-on-valid-code
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2002-07-22 04:56 UTC by Michael Meissner
Modified: 2003-07-25 17:33 UTC (History)
1 user (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed:


Attachments
xx.c (205 bytes, application/octet-stream)
2003-05-21 15:17 UTC, Michael Meissner
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Meissner 2002-07-22 04:56:02 UTC
When compiling the attached code snippet on S390X (64bit):

$ gcc -O1 xx.i
xx.c: In function `f':
xx.c:10: Internal compiler error in fixup_var_refs_1, at function.c:1964
Please submit a full bug report,
...

The error goes away with -O2 (probably because the stacktemp is removed).

Release:
gcc version 3.1.1 20020708 (prerelease)

Environment:
SuSE Linux 8.0.99 / s390x

How-To-Repeat:
compile attached file with -O1
Comment 1 Michael Meissner 2002-07-22 04:56:02 UTC
Fix:
noclue
Comment 2 Ulrich Weigand 2002-10-15 10:07:07 UTC
Responsible-Changed-From-To: unassigned->uweigand
Responsible-Changed-Why: s390 backend bug
Comment 3 Ulrich Weigand 2002-10-15 10:07:07 UTC
State-Changed-From-To: open->analyzed
State-Changed-Why: 'Inverted' addsi pattern not recognized.
Comment 4 Ulrich Weigand 2002-10-15 11:41:01 UTC
State-Changed-From-To: analyzed->closed
State-Changed-Why: Fixed in 3.2.1 and 3.3.
Comment 5 Ulrich Weigand 2002-10-15 18:34:37 UTC
From: uweigand@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: target/7370
Date: 15 Oct 2002 18:34:37 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Branch: 	gcc-3_2-branch
 Changes by:	uweigand@gcc.gnu.org	2002-10-15 11:34:37
 
 Modified files:
 	gcc            : ChangeLog 
 	gcc/config/s390: s390.md 
 
 Log message:
 	PR target/7370
 	* config/s390/s390.md ("*addsi3_inv"): New pattern.
 	
 	PR target/8232
 	* config/s390/s390.md ("cmpstrsi"): Convert length operand
 	from SImode to Pmode.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.13152.2.657.2.91&r2=1.13152.2.657.2.92
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/config/s390/s390.md.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.17.2.4&r2=1.17.2.4.2.1
 
Comment 6 Ulrich Weigand 2002-10-15 18:38:25 UTC
From: uweigand@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: target/7370
Date: 15 Oct 2002 18:38:25 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Branch: 	gcc-3_2-branch
 Changes by:	uweigand@gcc.gnu.org	2002-10-15 11:38:25
 
 Modified files:
 	gcc/testsuite  : ChangeLog 
 Added files:
 	gcc/testsuite/gcc.c-torture/compile: 20021015-1.c 20021015-2.c 
 
 Log message:
 	PR target/7370
 	* gcc.c-torture/compile/20021015-1.c: New test.
 	
 	PR target/8232
 	* gcc.c-torture/compile/20021015-2.c: New test.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.1672.2.166.2.27&r2=1.1672.2.166.2.28
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gcc.c-torture/compile/20021015-1.c.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=NONE&r2=1.1.2.1
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gcc.c-torture/compile/20021015-2.c.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=NONE&r2=1.1.2.1